//data.java Summer -Winter 2003
//Features:
// insPlayer(name, ship, freq)
// rmPlayer(name)
// reset()
// str[] lsPlayer()
// setFlags(name, str)
// str getFlags(name)
//21/12/03 Fixed lsPlayer returning data instead of keys
//23/12/03 Added methods to get freq/ship of player
//22/01/04 Added existPlayer(), useful for /priv auth and :priv: check

import java.io.*;
import java.util.Hashtable;
import java.util.Enumeration;

public class data
{
	static final int version = 4;

	static Hashtable pShip;
	static Hashtable pFreq;
	static Hashtable pData;

	public data()
	{
		pShip = new Hashtable(2);
		pFreq = new Hashtable(2);
		pData = new Hashtable(); //Optional flags
	}

	public void reset()
	{
		pShip = new Hashtable(2);
		pFreq = new Hashtable(2);
		//pData = new Hashtable(); //Optional flags
	}

	public void insPlayer(String name, String ship, String freq)
	{
		pShip.put(name, ship);
		pFreq.put(name, freq);
	}

	public void rmPlayer(String name)
	{
		//Safe even if name does not exist
		pShip.remove(name);
		pFreq.remove(name);
		//pData.remove(name);
	}

	public String[] lsPlayer()
	{
		int i = pShip.size();
		String[] names = new String[ i ];

		Enumeration e = pShip.keys();
		for(i=0; e.hasMoreElements(); i++)
		{
			names[i] = (String)e.nextElement();
		}
		return names;
	}

	public boolean existPlayer(String name)
	{
		String exist;
		name = name.toLowerCase();
		
		Enumeration e = pShip.keys();
		while(e.hasMoreElements())
		{
			exist = (String)e.nextElement();
			exist = exist.toLowerCase();
			if (exist.equals(name))
				return true;
		}

		return false;
	}

	public String getShip(String name)
	{
		return (String)pShip.get(name);
	}

	public String getFreq(String name)
	{
		return (String)pFreq.get(name);
	}

	public void setFlags(String name, String flags)
	{
		//Safe even if name does not exist
		pData.remove(name);
		pData.put(name, flags);
	}

	public String getFlags(String name)
	{
		//Returns null if name does not exist
		return (String)pData.get(name);
	}

}
