//ping.java Winter 2003
//Pings a SubSpace server to get player count

import java.io.*;
import java.net.*;

public class ping
{
	static final int version = 4;

	static loggers lm;

	private static DatagramSocket socket;

	public ping(loggers lm)
	{
		this.lm = lm;
	
		//Make socket
		try
		{
			socket = new DatagramSocket();
			socket.setSoTimeout(1500);
		}
		catch(SocketException e)
		{
			lm.Log("E", "<ping> " + e.getMessage());
			e.printStackTrace();
		}
		catch(Exception e)
		{
			lm.Log("E", "<ping> " + e.getMessage());
			e.printStackTrace();
		}
	}

	public int pingServer(String host, int port)
	{
		byte[] buf = new byte[4];

		long time = System.currentTimeMillis();
		int key = (int)( (time >> 2) & 0xFFFFFF );
		//System.out.println("key: " + key);
		buf[3] = (byte)(key >> 24);
		buf[2] = (byte)(key >> 16);
		buf[1] = (byte)(key >>  8);
		buf[0] = (byte)(key      );

		buf = pingServer(host, port, buf);
		if (buf == null)
			return -1;

		int i =
		        ((buf[3] & 0xFF) << 24) + 
		        ((buf[2] & 0xFF) << 16) + 
		        ((buf[1] & 0xFF) <<  8) + 
		         (buf[0] & 0xFF);

		int j =
		        ((buf[7] & 0xFF) << 24) + 
		        ((buf[6] & 0xFF) << 16) + 
		        ((buf[5] & 0xFF) <<  8) + 
		         (buf[4] & 0xFF);
		//System.out.println("key: " + j);

		return i;
	}

	public byte[] pingServer(String host, int port, byte[] buf)
	{
		InetAddress address = null;
		DatagramPacket pkt  = null;

		lm.Log("D", "<ping> Pinging: " + host + ":" + port);

		//Resolve address
		try
		{
			address = InetAddress.getByName(host);
		}
		catch(UnknownHostException e)
		{
			lm.Log("E", "<ping> Unknown host");
			return null;
		}

		//Create packet
		try
		{
			pkt = new DatagramPacket(buf, buf.length,
				address, port);
		}
		catch (Exception e)
		{
			lm.Log("E", "<ping> " + e.getMessage());
			e.printStackTrace();
			return null;
		}

		//Send packet
		try
		{
			socket.send(pkt);
		}
		catch (Exception e)
		{
			lm.Log("E", "<ping> " + e.getMessage());
			e.printStackTrace();
			return null;
		}

		//Receive
		try
		{
			buf = new byte[8];
			pkt = new DatagramPacket(buf, buf.length);
			socket.receive(pkt);
			//buf = pkt.getData();
		}
		catch(InterruptedIOException e)
		{
			//Timedout
			lm.Log("D", "<ping> Connection timed out");
			return null;
		}
		catch (Exception e)
		{
			lm.Log("E", "<ping> " + e.getMessage());
			e.printStackTrace();
			return null;
		}

		//for(int i=0; i<8; i++)
		//	System.out.println(buf[i]);

		return buf;
	}

	public void finish()
	{
		socket.close();
	}
}
